/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 280
#ifdef HAVE_CONFIG_H
#line 280
# include <config.h>
#line 280
#endif
#line 280
#include <sys/types.h>
#line 280

#line 280
#include "mailfromd.h"
#line 280
#include "prog.h"
#line 280
#include "builtin.h"
#line 280

#line 280

#line 767 "../../src/builtin/snarf.m4"

#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2018 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include "srvcfg.h"
#include "global.h"

void
#line 24
bi_primitive_hostname(eval_environ_t env)
#line 24

#line 24

#line 24 "dns.bi"
{
#line 24
	
#line 24

#line 24

#line 24
char * MFL_DATASEG string;
#line 24
        
#line 24
get_string_arg(env, 0, &string);
#line 24
        
#line 24

#line 24
        adjust_stack(env, 1);
#line 24

#line 24

#line 24
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 24
		prog_trace(env, "primitive_hostname %s",string);;
#line 24

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 30
		(
#line 30
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 30
)
#line 33
;
	
	pushs(env, hbuf);
	free(hbuf);
}

#line 38
        env_function_cleanup_flush(env, NULL);
#line 38
	return;
#line 38
}

void
#line 40
bi_primitive_resolve(eval_environ_t env)
#line 40

#line 40

#line 40 "dns.bi"
{
#line 40
	
#line 40

#line 40
long __bi_argcnt;
#line 40
char * MFL_DATASEG string;
#line 40
        char * MFL_DATASEG domain;
#line 40
        
#line 40
get_string_arg(env, 1, &string);
#line 40
        get_string_arg(env, 2, &domain);
#line 40
        
#line 40
get_numeric_arg(env, 0, &__bi_argcnt);
#line 40
        adjust_stack(env, __bi_argcnt + 1);
#line 40

#line 40

#line 40
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 40
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 40

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 47
		(
#line 47
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 47
)
#line 49
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 52
		(
#line 52
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 52
)
#line 54
;
	}
	pushs(env, ipstr);
	free(ipstr);
}

#line 59
        env_function_cleanup_flush(env, NULL);
#line 59
	return;
#line 59
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 73
bi_dns_getaddr(eval_environ_t env)
#line 73

#line 73

#line 73 "dns.bi"
{
#line 73
	
#line 73

#line 73

#line 73
char * MFL_DATASEG string;
#line 73
        
#line 73
get_string_arg(env, 0, &string);
#line 73
        
#line 73

#line 73
        adjust_stack(env, 1);
#line 73

#line 73

#line 73
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 73
		prog_trace(env, "dns_getaddr %s",string);;
#line 73

{
	size_t i;
	dns_status dnstat;
	struct dns_reply r;
	
	dnstat = a_lookup(string, &r);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(r.data.ip, r.count, sizeof r.data.ip[0], ipaddr_cmp);
		for (i = 0; i < r.count; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = r.data.ip[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 92
do {
#line 92
  char *__s = q;
#line 92
  heap_obstack_grow(env, __s, strlen(__s));
#line 92
} while (0);
		}
		dns_reply_free(&r);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 96
do {
#line 96
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 96
  goto endlab;
#line 96
} while (0);
	}
	case dns_not_found:
		
#line 99
do {
#line 99
  pushs(env, "");
#line 99
  goto endlab;
#line 99
} while (0);
	default:
		(
#line 101
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(dnstat)), "dns_getaddr", _("failed to get A record for %s"),string)
#line 101
);
#line 103
	}
}
endlab:
#line 105
        env_function_cleanup_flush(env, NULL);
#line 105
	return;
#line 105
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 113
bi_dns_getname(eval_environ_t env)
#line 113

#line 113

#line 113 "dns.bi"
{
#line 113
	
#line 113

#line 113

#line 113
char * MFL_DATASEG ipstr;
#line 113
        
#line 113
get_string_arg(env, 0, &ipstr);
#line 113
        
#line 113

#line 113
        adjust_stack(env, 1);
#line 113

#line 113

#line 113
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 113
		prog_trace(env, "dns_getname %s",ipstr);;
#line 113

{
	dns_status dnstat;
	struct in_addr addr;
	struct dns_reply r;
	
		if (!(inet_aton(ipstr, &addr)))
#line 119
		(
#line 119
	env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 119
)
#line 121
;

	dnstat = ptr_lookup(addr, &r);
	switch (dnstat) {
	case dns_success: {
		size_t i;

		qsort(r.data.str, r.count, sizeof r.data.str[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < r.count; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 134
do {
#line 134
  char *__s = (char*)r.data.str[i];
#line 134
  heap_obstack_grow(env, __s, strlen(__s));
#line 134
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		dns_reply_free(&r);
		
#line 139
do {
#line 139
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 139
  goto endlab;
#line 139
} while (0);
	}
	case dns_not_found:
		
#line 142
do {
#line 142
  pushs(env, "");
#line 142
  goto endlab;
#line 142
} while (0);
	default:
		(
#line 144
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(dnstat)), "dns_getname", _("failed to get PTR record for %s"),ipstr)
#line 144
);
#line 146
	}
}
endlab:
#line 148
        env_function_cleanup_flush(env, NULL);
#line 148
	return;
#line 148
}

void
#line 150
bi_primitive_hasmx(eval_environ_t env)
#line 150

#line 150

#line 150 "dns.bi"
{
#line 150
	
#line 150

#line 150

#line 150
char *  string;
#line 150
        
#line 150
get_string_arg(env, 0, &string);
#line 150
        
#line 150

#line 150
        adjust_stack(env, 1);
#line 150

#line 150

#line 150
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 150
		prog_trace(env, "primitive_hasmx %s",string);;
#line 150

{
	struct dns_reply repl;
	mf_status mxstat;

	mxstat = dns_to_mf_status(mx_lookup(string, 0, &repl));
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 157
		(
#line 157
	env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 157
)
#line 160
;
	dns_reply_free(&repl);
	if (mxstat == mf_success) {
		
#line 163
do {
#line 163
  push(env, (STKVAL)(mft_number)(1));
#line 163
  goto endlab;
#line 163
} while (0);
	}
	
#line 165
do {
#line 165
  push(env, (STKVAL)(mft_number)(0));
#line 165
  goto endlab;
#line 165
} while (0);
}
endlab:
#line 167
        env_function_cleanup_flush(env, NULL);
#line 167
	return;
#line 167
}

void
#line 169
bi_getmx(eval_environ_t env)
#line 169

#line 169

#line 169 "dns.bi"
{
#line 169
	
#line 169

#line 169
long __bi_argcnt;
#line 169
char * MFL_DATASEG domain;
#line 169
        long  resolve;
#line 169
        
#line 169
get_string_arg(env, 1, &domain);
#line 169
        get_numeric_arg(env, 2, &resolve);
#line 169
        
#line 169
get_numeric_arg(env, 0, &__bi_argcnt);
#line 169
        adjust_stack(env, __bi_argcnt + 1);
#line 169

#line 169

#line 169
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 169
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? resolve : 0));;
#line 169

{
	mf_status mxstat;
	struct dns_reply reply;
	int i;
	
	mxstat = dns_to_mf_status(mx_lookup(domain, ((__bi_argcnt > 1) ? resolve : 0),
					    &reply));
	if (!mf_resolved(mxstat)) {
		(
#line 178
	env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain)
#line 178
);
#line 180
	}
	if (mxstat == mf_not_found) {
		
#line 182
do {
#line 182
  pushs(env, "");
#line 182
  goto endlab;
#line 182
} while (0);
	} else if (reply.type == dns_reply_ip) {
		heap_obstack_begin(env);
		for (i = 0; i < reply.count; i++) {
			struct in_addr s;
			s.s_addr = reply.data.ip[i];
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 190
do {
#line 190
  char *__s = inet_ntoa(s);
#line 190
  heap_obstack_grow(env, __s, strlen(__s));
#line 190
} while (0);
		}
	} else {
		heap_obstack_begin(env);
		for (i = 0; i < reply.count; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 197
do {
#line 197
  char *__s = reply.data.str[i];
#line 197
  heap_obstack_grow(env, __s, strlen(__s));
#line 197
} while (0);
		}
	}
	do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
	dns_reply_free(&reply);
	
#line 202
do {
#line 202
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 202
  goto endlab;
#line 202
} while (0);
}
endlab:
#line 204
        env_function_cleanup_flush(env, NULL);
#line 204
	return;
#line 204
}

static dns_status
resolve_host(const char *string, struct dns_reply *reply)
{
	struct in_addr addr;

	if (inet_aton(string, &addr)) {
		dns_reply_init(reply, dns_reply_ip, 1);
		reply->data.ip[0] = addr.s_addr;
		return dns_success;
	}
	return a_lookup(string, reply);
}

static int
dns_replies_intersect(struct dns_reply const *a, struct dns_reply const *b)
{
	int i, j;
	
	if (a->type == b->type && a->type == dns_reply_ip) {
		for (i = 0; i < a->count; i++) 
			for (j = 0; j < b->count; j++) 
				if (a->data.ip[i] == b->data.ip[j])
					return 1;
	}
	return 0;
}

void
#line 233
bi_primitive_ismx(eval_environ_t env)
#line 233

#line 233

#line 233 "dns.bi"
{
#line 233
	
#line 233

#line 233

#line 233
char *  domain;
#line 233
        char *  ipstr;
#line 233
        
#line 233
get_string_arg(env, 0, &domain);
#line 233
        get_string_arg(env, 1, &ipstr);
#line 233
        
#line 233

#line 233
        adjust_stack(env, 2);
#line 233

#line 233

#line 233
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 233
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 233

{
	struct dns_reply areply, mxreply;
	dns_status status;
	int rc = 0;

	status = resolve_host(ipstr, &areply);
		if (!(status == dns_success))
#line 240
		(
#line 240
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(status)), "primitive_ismx", _("cannot resolve host name %s"),ipstr)
#line 240
)
#line 242
;
	status = mx_lookup(domain, 1, &mxreply);
	if (status != dns_success) {
		dns_reply_free(&areply);
		(
#line 246
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(status)), "primitive_ismx", _("cannot get MXs for %s"),domain)
#line 246
);
#line 248
	}
	rc = dns_replies_intersect(&areply, &mxreply);
	dns_reply_free(&areply);
	dns_reply_free(&mxreply);
	
#line 252
do {
#line 252
  push(env, (STKVAL)(mft_number)(rc));
#line 252
  goto endlab;
#line 252
} while (0);
}
endlab:
#line 254
        env_function_cleanup_flush(env, NULL);
#line 254
	return;
#line 254
}

void
#line 256
bi_relayed(eval_environ_t env)
#line 256

#line 256

#line 256 "dns.bi"
{
#line 256
	
#line 256

#line 256

#line 256
char *  s;
#line 256
        
#line 256
get_string_arg(env, 0, &s);
#line 256
        
#line 256

#line 256
        adjust_stack(env, 1);
#line 256

#line 256

#line 256
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 256
		prog_trace(env, "relayed %s",s);;
#line 256

{
	
#line 258
do {
#line 258
  push(env, (STKVAL)(mft_number)(relayed_domain_p(s)));
#line 258
  goto endlab;
#line 258
} while (0);
}
endlab:
#line 260
        env_function_cleanup_flush(env, NULL);
#line 260
	return;
#line 260
}

void
#line 262
bi_ptr_validate(eval_environ_t env)
#line 262

#line 262

#line 262 "dns.bi"
{
#line 262
	
#line 262

#line 262

#line 262
char *  s;
#line 262
        
#line 262
get_string_arg(env, 0, &s);
#line 262
        
#line 262

#line 262
        adjust_stack(env, 1);
#line 262

#line 262

#line 262
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 262
		prog_trace(env, "ptr_validate %s",s);;
#line 262

{
	int rc, res;
	switch (rc = ptr_validate(s, NULL)) {
	case dns_success:
		res = 1;
		break;
	case dns_not_found:
		res = 0;
		break;
	default:
		(
#line 273
	env_throw_bi(env, mf_status_to_exception(dns_to_mf_status(rc)), "ptr_validate", _("failed to get PTR record for %s"),s)
#line 273
);
#line 275
	}
	
#line 276
do {
#line 276
  push(env, (STKVAL)(mft_number)(res));
#line 276
  goto endlab;
#line 276
} while (0);
}
endlab:
#line 278
        env_function_cleanup_flush(env, NULL);
#line 278
	return;
#line 278
}


#line 280
void
#line 280
dns_init_builtin()
#line 280
{
#line 280
	
#line 280
	#line 24 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 40 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 73 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 113 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 150 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 169 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 233 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 256 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 262 "dns.bi"
va_builtin_install_ex("ptr_validate", bi_ptr_validate, 0, dtype_number, 1, 0, 0|0, dtype_string);

#line 280 "dns.bi"
	
#line 280
}
#line 280 "dns.bi"

#line 280

#line 761 "../../src/builtin/snarf.m4"

#line 761

